// VirusPortInputListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PacketAnalyzer.h"
#include "VirusPortInputListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVirusPortInputListDlg dialog


CVirusPortInputListDlg::CVirusPortInputListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVirusPortInputListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVirusPortInputListDlg)
	//}}AFX_DATA_INIT
}


void CVirusPortInputListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVirusPortInputListDlg)
	DDX_Control(pDX, IDC_VIRUS_PORT, m_cVirusPort);
	DDX_Control(pDX, IDC_VIRUS_INFO, m_cVirusInfo);
	DDX_Control(pDX, IDC_VIRUS_PORT_LIST, m_cVirusPortList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVirusPortInputListDlg, CDialog)
	//{{AFX_MSG_MAP(CVirusPortInputListDlg)
	ON_BN_CLICKED(IDC_VIRUS_INPUT, OnVirusInput)
	ON_BN_CLICKED(IDC_VIRUS_PORT_DEL, OnVirusPortDel)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_VIRUS_PORT_LIST, OnItemchangedVirusPortList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVirusPortInputListDlg message handlers

void CVirusPortInputListDlg::OnVirusInput() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString strBuff,strPort,strInfo;

	m_cVirusPort.GetWindowText(strPort);
	m_cVirusInfo.GetWindowText(strInfo);
	
	//Ʈ ׸ ߰
	if(strPort == "" && strInfo == "")
	{
		AfxMessageBox("̷ Ʈ ȣ  Էϼ!!");
	} else {
		int nCount = m_cVirusPortList.GetItemCount();
		
		strBuff.Format("%d",nCount + 1);
	
		m_cVirusPortList.InsertItem(nCount,strBuff);
		m_cVirusPortList.SetItemText(nCount,1,strPort);
		m_cVirusPortList.SetItemText(nCount,2,strInfo);

		WritePrivateProfileSection(strBuff,"",m_strFilePath);
		WritePrivateProfileString(strBuff,"Port",strPort,m_strFilePath);
		WritePrivateProfileString(strBuff,"Info",strInfo,m_strFilePath);
		
		m_cVirusPort.SetWindowText("");
		m_cVirusInfo.SetWindowText("");
	}
}

BOOL CVirusPortInputListDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_strFilePath = ".\\virusport.ini";

	CFileFind cFind;

	if(!cFind.FindFile(m_strFilePath)){
		CFile file;
		CString str(";Virus Port List  ini ");
		file.Open(m_strFilePath,CFile::modeCreate | CFile::modeWrite);
		file.Write(str,str.GetLength());
		file.Close();
	}
	
	m_cVirusPortList.InsertColumn(0,"No",LVCFMT_LEFT,0,0);
	m_cVirusPortList.InsertColumn(1,"Port",LVCFMT_LEFT,100,0);
	m_cVirusPortList.InsertColumn(2,"Information",LVCFMT_LEFT,230,0);
	m_cVirusPortList.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	char tmp[1024];
	memset(tmp,'\0',1024);
	GetPrivateProfileSectionNames(tmp,1024,m_strFilePath);

	CString strSection;
	strSection.Empty();
	int index = 0;
	char port[5];
	char info[256];
	CString strPort,strInfo;

	//ini Ͽ ǰ ,,
	for(int i = 0 ; i<1024 ; i++) 
	{
		if(tmp[i])
			strSection += tmp[i];
		else
		{
			m_cVirusPortList.InsertItem(index,strSection);
			
			GetPrivateProfileString(strSection,"Port","",port,5,m_strFilePath);
			strPort.Format("%s",port);
			m_cVirusPortList.SetItemText(index,1,strPort);
			
			GetPrivateProfileString(strSection,"Info","",info,256,m_strFilePath);
			strInfo.Format("%s",info);
			m_cVirusPortList.SetItemText(index,2,strInfo);

			strSection.Empty();
			index += 1;
		}
		if(tmp[i] == NULL && tmp[i+1] == NULL)
			break;
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CVirusPortInputListDlg::OnVirusPortDel() 
{
	// TODO: Add your control notification handler code here
	
	//õ Ʈ ׸ 
	if(m_nSelectedItem < m_cVirusPortList.GetItemCount() && (m_nSelectedItem >= 0))
	{
		m_cVirusPortList.DeleteItem(m_nSelectedItem);
		
		//INI Ͽ ׸ 
		CString str;
		str.Format("%d",m_nSelectedItem+1);
		WritePrivateProfileSection(str,NULL,m_strFilePath);
	}

	
}



void CVirusPortInputListDlg::OnItemchangedVirusPortList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	m_nSelectedItem = pNMListView->iItem;

	*pResult = 0;
}
