// CaptureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PacketAnalyzer.h"
#include "CaptureDlg.h"
#include "PacketAnalyzerDoc.h"
#include "MainFrm.h"
#include "PacketListView.h"
#include "VirusPortInputListDlg.h"

#include "pcap.h"

#include "WINSOCK2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCaptureDlg dialog


CCaptureDlg::CCaptureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCaptureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCaptureDlg)
	m_strIpaddress = _T("");
	m_strPortNum = _T("");
	m_strMaxPacketNum = _T("");
	m_bArpCheck = FALSE;
	m_bIcmpCheck = FALSE;
	m_bTcpCheck = FALSE;
	m_bUdpCheck = FALSE;
	m_bVirusPortCheck = FALSE;
	m_bVirusScan = FALSE;
	//}}AFX_DATA_INIT
	
}


void CCaptureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureDlg)
	DDX_Control(pDX, IDC_CHECK_VIRUS_ON, m_cVirusPortScanCheck);
	DDX_Control(pDX, IDC_BUTTON_VIRUS_LIST, m_cVirusListButton);
	DDX_Control(pDX, IDC_PORT_NUM, m_cPortNum);
	DDX_Control(pDX, IDC_UDP_CHECK, m_cUdpCheck);
	DDX_Control(pDX, IDC_TCP_CHECK, m_cTcpCheck);
	DDX_Control(pDX, IDC_ICMP_CHECK, m_cIcmpCheck);
	DDX_Control(pDX, IDC_ARP_CHECK, m_cArpCheck);
	DDX_Control(pDX, IDC_MAX_PACKET, m_cMaxPacketNum);
	DDX_Control(pDX, ID_CAPTURE_STOP, m_CaptureStopButton);
	DDX_Control(pDX, ID_CAPTURE_START, m_CaptureStartButton);
	DDX_Control(pDX, IDC_INTERFACE_COMBO, m_cbInterface);
	DDX_Text(pDX, IDC_IPADDRESS, m_strIpaddress);
	DDX_Text(pDX, IDC_PORT_NUM, m_strPortNum);
	DDX_Text(pDX, IDC_MAX_PACKET, m_strMaxPacketNum);
	DDX_Check(pDX, IDC_ARP_CHECK, m_bArpCheck);
	DDX_Check(pDX, IDC_ICMP_CHECK, m_bIcmpCheck);
	DDX_Check(pDX, IDC_TCP_CHECK, m_bTcpCheck);
	DDX_Check(pDX, IDC_UDP_CHECK, m_bUdpCheck);
	DDX_Check(pDX, IDC_CHECK_VIRUS_ON, m_bVirusScan);
	//}}AFX_DATA_MAP
	
}


BEGIN_MESSAGE_MAP(CCaptureDlg, CDialog)
	//{{AFX_MSG_MAP(CCaptureDlg)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_VIRUS_LIST, OnButtonVirusList)
	ON_BN_CLICKED(ID_CAPTURE_START, OnCaptureStart)
	ON_BN_CLICKED(ID_CAPTURE_STOP, OnCaptureStop)
	ON_BN_CLICKED(IDC_CHECK_VIRUS_ON, OnCheckVirusOn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCaptureDlg message handlers

void CCaptureDlg::OnCaptureStart() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
	
	//happython :: 忡 CMainFrame ͸  ⶧ 
	//happython :: pThis  ̿Ͽ ߸
	//happython :: CMainFrame Ŭ  ϰ MainFrame  ͸ 
	//happython :: 2005/2/16
	pMainFrame = (CMainFrame *)AfxGetMainWnd();

	if((atoi(m_strMaxPacketNum) <= 1000) && (m_strMaxPacketNum != "")) {
		CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
		//ʱȭ-------------------------------------------
		pFrame->SetListViewClear();
		pFrame->m_pPacketInfoScrollView->ClearInfoView();
		pFrame->m_pPacketGraphView->ClearView();
		pFrame->g_PacketDataList.RemoveAll();
		pFrame->m_pPacketHexaView->m_wndEdit.SetWindowText(" ");
		pFrame->m_nArpCount = 0;
		pFrame->m_nIcmpCount = 0;
		pFrame->m_nTcpCount = 0;
		pFrame->m_nUdpCount = 0;
		//-------------------------------------------------

		int nIndex = m_cbInterface.GetCurSel();
	
		CString str;	
	
		if(nIndex != CB_ERR){
			m_cbInterface.GetLBText(nIndex,str);
		}
	
		m_strSelectDevName = m_strDevName[nIndex];

		DWORD dwThreadID = 0;
		HANDLE m_hThread;
	
		//    
		m_bCaptureState = TRUE;
	
		//ư Ȱȭ, Ȱȭ
		m_CaptureStartButton.EnableWindow(FALSE);
		m_CaptureStopButton.EnableWindow(TRUE);
		m_cbInterface.EnableWindow(FALSE);
		m_cArpCheck.EnableWindow(FALSE);
		m_cIcmpCheck.EnableWindow(FALSE);
		m_cTcpCheck.EnableWindow(FALSE);
		m_cUdpCheck.EnableWindow(FALSE);
		m_cMaxPacketNum.EnableWindow(FALSE);
		m_cPortNum.EnableWindow(FALSE);
		m_cVirusPortScanCheck.EnableWindow(FALSE);
		m_cVirusListButton.EnableWindow(FALSE);

		if(m_bVirusScan == 0) {
			// 
			if((m_hThread = CreateThread(NULL,0,CCaptureDlg::PacketCaptureThread,this,0,&dwThreadID)) != NULL){
				//    
				m_bCaptureState = TRUE;
			}
		} else {
			if((m_hThread = CreateThread(NULL,0,CCaptureDlg::VirusPortScanThread,this,0,&dwThreadID)) != NULL){
				//    
				m_bCaptureState = TRUE;
			}		

		}

	} else {
		AfxMessageBox("ִ ĸ Ŷ 1000  Դϴ");
		m_cMaxPacketNum.SetFocus();
	}
	
}

void CCaptureDlg::OnCaptureStop() 
{
	// TODO: Add your control notification handler code here
	m_bCaptureState = FALSE;
	SendMessage(WM_CLOSE);
}

BOOL CCaptureDlg::OnInitDialog() 
{
	char szHostName[40];

	CDialog::OnInitDialog();
	
	//ư ʱȭ
	m_CaptureStopButton.EnableWindow(FALSE);
	m_cVirusListButton.EnableWindow(FALSE);
	
	// TODO: Add extra initialization here
	pcap_if_t *pAllDevs, *pD;
	
	int nIndex;
	
	//Ʈ̽
	if(pcap_findalldevs(&pAllDevs,cErrBuf) != -1){
		for(pD=pAllDevs,nIndex = 0;pD != NULL;pD=pD->next,nIndex++){
			
			m_cbInterface.AddString(pD->description);
			m_strDevName[nIndex] = pD->name;
		}
	}
	m_cbInterface.SetCurSel(0);

	pcap_freealldevs(pAllDevs);

	//IP ּ
	if(gethostname(szHostName, sizeof(szHostName)) != SOCKET_ERROR) {
		struct hostent* pHostEnt = NULL;
		
		if ((pHostEnt = gethostbyname(szHostName)) != NULL) {
			unsigned long IPAddr = 0;
			int	nIndex = 0;
			CString	strIPAddressList = "";
			
			if(pHostEnt->h_addr_list[nIndex] != NULL) {
				CString	strIPAddress = "";
				
				memcpy(&IPAddr, pHostEnt->h_addr_list[nIndex], sizeof(long));
				strIPAddress = inet_ntoa(*(struct in_addr*)&IPAddr);
				
				strIPAddressList += strIPAddress;
				strIPAddressList += " ";
				nIndex++;
				
			}
			
		m_strIpaddress.Format("%s",strIPAddressList);
		m_strMaxPacketNum = "1000";
		UpdateData(FALSE);
		}
	}
	
	// üũ
	((CButton*)GetDlgItem(IDC_TCP_CHECK))->SetCheck(TRUE);
	((CButton*)GetDlgItem(IDC_UDP_CHECK))->SetCheck(TRUE);
	((CButton*)GetDlgItem(IDC_ARP_CHECK))->SetCheck(TRUE);
	((CButton*)GetDlgItem(IDC_ICMP_CHECK))->SetCheck(TRUE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

DWORD WINAPI CCaptureDlg::VirusPortScanThread(LPVOID lpParam)
{
	CCaptureDlg* pThis = (CCaptureDlg*)lpParam;
	
	CString strFilePath = ".\\virusport.ini";

	CFileFind cFind;
	if(!cFind.FindFile(strFilePath)){
		AfxMessageBox(" ã ϴ!");
		pThis->SendMessage(WM_CLOSE);
	}
	
	char port[5];
	char tmp[1024];
	char info[256];
	memset(tmp,'\0',1024);
	GetPrivateProfileSectionNames(tmp,1024,strFilePath);
	
	int index = 0;
	int nPort[256];
	CString strSection;
	CString strBuff;
	CString strInfo[256];

	//ini Ͽ port ȣ 
	for(int i = 0 ; i<1024 ; i++) 
	{
		if(tmp[i])
			strSection += tmp[i];
		else
		{
					
			GetPrivateProfileString(strSection,"Port","Error",port,5,strFilePath);
			strBuff.Format("%s",port);
			nPort[index] = atoi(strBuff);
			
			GetPrivateProfileString(strSection,"Info","Error",info,256,strFilePath);
			strInfo[index].Format("%s",info);

			strSection.Empty();
			index += 1;
		}
		if(tmp[i] == NULL && tmp[i+1] == NULL)
			break;
	}
	
	//================================================================================//
	//Ŷ 
	//================================================================================//
		
	struct pcap_pkthdr *pPacketHeader = NULL;
	int nCaptureResult = 0;
	int nIndex = 1;
	unsigned char *pPacketData = NULL;
		
	//̽ descriptor
	pcap_t *pPcd;
	pPcd = pcap_open_live(pThis->m_strSelectDevName,BUFSIZ,0,-1,pThis->cErrBuf);
	
	while((atoi(pThis->m_strMaxPacketNum) >= nIndex) && (pThis->m_bCaptureState == TRUE) && (nCaptureResult = pcap_next_ex(pPcd,&pPacketHeader,&pPacketData)) >= 0)	
	{
		if((pPacketHeader != NULL) && (pPacketData != NULL))
		{
			
			ETHER_HEADER* pEtherHeader = NULL;
			ushort_t nEtherType;
			PACKET_DATA sPacketData;
			CString strBuff;

			u_char*	pPacket = pPacketData;

			pEtherHeader = (ETHER_HEADER*)pPacket;
			pPacket += sizeof(ETHER_HEADER);
			nEtherType = ntohs(pEtherHeader->ether_type);

			pThis->pMainFrame->nLength = pPacketHeader->len;
			pThis->pMainFrame->nEtherType = nEtherType;
			
			if (nEtherType == ETHERTYPE_IP)
			{
				IP_HEADER *pIPHeader = (IP_HEADER *)pPacket;

				pThis->pMainFrame->strSrcAddr = inet_ntoa(pIPHeader->ip_src);
				pThis->pMainFrame->strDstAddr = inet_ntoa(pIPHeader->ip_dst);
								
				if ((pIPHeader->ip_p == IPPROTO_TCP) && (pThis->m_bTcpCheck == 1)) 
				{
					TCP_HEADER* pTCPHeader = (TCP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);

					pThis->pMainFrame->nSrcPort = ntohs(pTCPHeader->th_sport);
					pThis->pMainFrame->nDstPort = ntohs(pTCPHeader->th_dport);
					pThis->pMainFrame->strProtocol = "TCP";
					
					//̷ Ʈ ˻  Ŷ 
					for(int i = 0 ; i <= index ; i++)
					{
						if((ntohs(pTCPHeader->th_sport)) == nPort[i] || (ntohs(pTCPHeader->th_dport)) == nPort[i])
						{
							strBuff.Format("%d",nIndex);
							sPacketData.index = strBuff;
							memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
							if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
								pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
								pThis->pMainFrame->m_nTcpCount += 1;
								pThis->pMainFrame->m_strInfo = strInfo[i];
								pThis->pMainFrame->SetListView(nIndex);
															
							}
							nIndex = nIndex + 1;
						}
					}
					
				}

				else if ((pIPHeader->ip_p == IPPROTO_UDP) && (pThis->m_bUdpCheck == 1))
				{
					UDP_HEADER* pUDPHeader = (UDP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);

					pThis->pMainFrame->nSrcPort = ntohs(pUDPHeader->uh_sport);
					pThis->pMainFrame->nDstPort = ntohs(pUDPHeader->uh_dport);
					pThis->pMainFrame->strProtocol = "UDP";
					
					//̷ Ʈ ˻  Ŷ 
					for(int i = 0 ; i <= index ; i++)
					{
						if((ntohs(pUDPHeader->uh_sport)) == nPort[i] || (ntohs(pUDPHeader->uh_dport)) == nPort[i])
						{
							strBuff.Format("%d",nIndex);
							sPacketData.index = strBuff;
							memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
							if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
								pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
								pThis->pMainFrame->m_nTcpCount += 1;
								pThis->pMainFrame->m_strInfo = strInfo[i];
								pThis->pMainFrame->SetListView(nIndex);
															
							}
							nIndex = nIndex + 1;
						}
					}
				}
			}
		}
		pPacketHeader = NULL;
		pPacketData = NULL;
	}
	pcap_close(pPcd);
	pThis->SendMessage(WM_CLOSE);
	//================================================================================//

	return 0;
}

void CCaptureDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	m_bCaptureState = FALSE;
	CDialog::OnClose();
}

void CCaptureDlg::OnButtonVirusList() 
{
	// TODO: Add your control notification handler code here
	CVirusPortInputListDlg dlg;
	dlg.DoModal();
}

void CCaptureDlg::OnCheckVirusOn() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bVirusScan == 1){
		m_cVirusListButton.EnableWindow(TRUE);
		m_cArpCheck.EnableWindow(FALSE);
		m_cIcmpCheck.EnableWindow(FALSE);
		m_cTcpCheck.EnableWindow(FALSE);
		m_cUdpCheck.EnableWindow(FALSE);
		m_cPortNum.EnableWindow(FALSE);
	} else {
		m_cVirusListButton.EnableWindow(FALSE);
		m_cArpCheck.EnableWindow(TRUE);
		m_cIcmpCheck.EnableWindow(TRUE);
		m_cTcpCheck.EnableWindow(TRUE);
		m_cUdpCheck.EnableWindow(TRUE);
		m_cPortNum.EnableWindow(TRUE);
	}
}

DWORD WINAPI CCaptureDlg::PacketCaptureThread(LPVOID lpParam)
{
	CCaptureDlg* pThis = (CCaptureDlg*)lpParam;

	struct pcap_pkthdr *pPacketHeader = NULL;
	int nCaptureResult = 0;
	int nIndex = 1;
	unsigned char *pPacketData = NULL;
	
	
	//̽ descriptor
	pcap_t *pPcd;
	pPcd = pcap_open_live(pThis->m_strSelectDevName,BUFSIZ,0,-1,pThis->cErrBuf);
	
	//pcap_freealldevs(pThis->m_strSelectDevName);
	
	while((atoi(pThis->m_strMaxPacketNum) >= nIndex) && (pThis->m_bCaptureState == TRUE) && (nCaptureResult = pcap_next_ex(pPcd,&pPacketHeader,&pPacketData)) >= 0)	
	{
		if((pPacketHeader != NULL) && (pPacketData != NULL))
		{
			
			ETHER_HEADER* pEtherHeader = NULL;
			ushort_t nEtherType;
			PACKET_DATA sPacketData;
			CString strBuff;

			u_char*	pPacket = pPacketData;

			pEtherHeader = (ETHER_HEADER*)pPacket;
			pPacket += sizeof(ETHER_HEADER);
			nEtherType = ntohs(pEtherHeader->ether_type);
	
			pThis->pMainFrame->nLength = pPacketHeader->len;
			pThis->pMainFrame->nEtherType = nEtherType;
			/*
			pFrame->nLength = pPacketHeader->len;
			pFrame->nEtherType = nEtherType;
			*/
			
			if (nEtherType == ETHERTYPE_IP)
			{
				IP_HEADER *pIPHeader = (IP_HEADER *)pPacket;

				pThis->pMainFrame->strSrcAddr = inet_ntoa(pIPHeader->ip_src);
				pThis->pMainFrame->strDstAddr = inet_ntoa(pIPHeader->ip_dst);
								
				if ((pIPHeader->ip_p == IPPROTO_TCP) && (pThis->m_bTcpCheck == 1)) 
				{
					TCP_HEADER* pTCPHeader = (TCP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);

					pThis->pMainFrame->nSrcPort = ntohs(pTCPHeader->th_sport);
					pThis->pMainFrame->nDstPort = ntohs(pTCPHeader->th_dport);
					pThis->pMainFrame->strProtocol = "TCP";
					
					//Ŷ 
					if(pThis->m_strPortNum != "")
					{
						if((pThis->pMainFrame->nSrcPort == (unsigned)atoi(pThis->m_strPortNum)) || (pThis->pMainFrame->nDstPort == (unsigned)atoi(pThis->m_strPortNum )))
						{
							strBuff.Format("%d",nIndex);
							sPacketData.index = strBuff;
							memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
							if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
								pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
								pThis->pMainFrame->m_nTcpCount += 1;
								pThis->pMainFrame->SetListView(nIndex);
								
								
							}
							nIndex = nIndex + 1;
						}
					} else {
						strBuff.Format("%d",nIndex);
						sPacketData.index = strBuff;
						memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
						if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
							pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
							pThis->pMainFrame->m_nTcpCount += 1;
							pThis->pMainFrame->SetListView(nIndex);
							
						}
						nIndex = nIndex + 1;
					}
				}

				else if ((pIPHeader->ip_p == IPPROTO_UDP) && (pThis->m_bUdpCheck == 1))
				{
					UDP_HEADER* pUDPHeader = (UDP_HEADER*)(pPacket + pIPHeader->ip_hl * 4);

					pThis->pMainFrame->nSrcPort = ntohs(pUDPHeader->uh_sport);
					pThis->pMainFrame->nDstPort = ntohs(pUDPHeader->uh_dport);
					pThis->pMainFrame->strProtocol = "UDP";
					
					//Ŷ 
					if(pThis->m_strPortNum != "")
					{
						if((pThis->pMainFrame->nSrcPort == (unsigned)atoi(pThis->m_strPortNum)) || (pThis->pMainFrame->nDstPort == (unsigned)atoi(pThis->m_strPortNum )))
						{
							strBuff.Format("%d",nIndex);
							sPacketData.index = strBuff;
							memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
							if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
								pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
								pThis->pMainFrame->m_nUdpCount += 1;
								pThis->pMainFrame->SetListView(nIndex);
								
							}
							nIndex = nIndex + 1;
						}
					} else {
						strBuff.Format("%d",nIndex);
						sPacketData.index = strBuff;
						memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
						if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
							pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
							pThis->pMainFrame->m_nUdpCount += 1;
							pThis->pMainFrame->SetListView(nIndex);
							
						}
						nIndex = nIndex + 1;
					}
				}
				else if ((pIPHeader->ip_p == IPPROTO_ICMP) && (pThis->m_bIcmpCheck == 1) && (pThis->m_strPortNum == ""))
				{
					ICMP_HEADER* pICMPHeader = (ICMP_HEADER*)(pPacket + pIPHeader->ip_hl *4);
					
					pThis->pMainFrame->nSrcPort = 0;
					pThis->pMainFrame->nDstPort = 0;
					CString strBuff;
					switch(pICMPHeader->type)
					{
						case 0 :
							strBuff = "Echo Reply";
							break;
						case 3 :
							strBuff = "Destination Unreachable";
							break;
						case 4 :
							strBuff = "Source Quench";
							break;
						case 5 :
							strBuff = "Redirect(change route)";
							break;
						case 8 :
							strBuff = "Echo Request";
							break;
						case 11:
							strBuff = "Time Exceeded";
							break;
						case 12 :
							strBuff = "Parameter Problem";
							break;
						case 13 :
							strBuff = "Timestamp Request";
							break;
						case 14 :
							strBuff = "Timestamp Reply";
							break;
						case 15 :
							strBuff = "Information Request";
							break;
						case 16 :
							strBuff = "Information Reply";
							break;
						case 17 :
							strBuff = "Address Mask Request";
							break;
						case 18 :
							strBuff = "Address Mask Reply";
							break;
					}
					pThis->pMainFrame->m_strInfo = strBuff;
					pThis->pMainFrame->strProtocol = "ICMP";
					
					//Ŷ
					strBuff.Format("%d",nIndex);
					sPacketData.index = strBuff;
					memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
					if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
						pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
						pThis->pMainFrame->m_nIcmpCount += 1;
						pThis->pMainFrame->SetListView(nIndex);
						
					}
					nIndex = nIndex + 1;
				}
			}
			
			else if ((nEtherType == ETHERTYPE_ARP) && (pThis->m_bArpCheck == 1) && (pThis->m_strPortNum == ""))
			{
				ARP_HEADER* pARPHeader = (ARP_HEADER*)pPacket;
				struct in_addr arp_sip, arp_tip;

				memcpy(&arp_sip, pARPHeader->ar_spa,4);
				memcpy(&arp_tip, pARPHeader->ar_tpa,4);

				pThis->pMainFrame->nSrcPort = 0;
				pThis->pMainFrame->nDstPort = 0;
				pThis->pMainFrame->strSrcAddr = inet_ntoa(arp_sip);
				pThis->pMainFrame->strDstAddr = inet_ntoa(arp_tip);
				pThis->pMainFrame->strProtocol = "ARP";
				
				//Ŷ 
				strBuff.Format("%d",nIndex);
				sPacketData.index = strBuff;
				memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
				if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
					pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
					pThis->pMainFrame->m_nArpCount += 1;
					pThis->pMainFrame->SetListView(nIndex);
					
				}

				nIndex = nIndex + 1;
			}
			
			else if ((nEtherType == ETHERTYPE_REVARP) && (pThis->m_bArpCheck == 1) && (pThis->m_strPortNum == ""))
			{
				ARP_HEADER* pRARPHeader = (ARP_HEADER*)pPacket;
				struct in_addr arp_sip, arp_tip;

				memcpy(&arp_sip, pRARPHeader->ar_spa,4);
				memcpy(&arp_tip, pRARPHeader->ar_tpa,4);

				pThis->pMainFrame->nSrcPort = 0;
				pThis->pMainFrame->nDstPort = 0;
				pThis->pMainFrame->strSrcAddr = inet_ntoa(arp_sip);
				pThis->pMainFrame->strDstAddr = inet_ntoa(arp_tip);
				pThis->pMainFrame->strProtocol = "RARP";
				
				//Ŷ 
				strBuff.Format("%d",nIndex);
				sPacketData.index = strBuff;
				memcpy(sPacketData.packetdata,pPacketData,pPacketHeader->len);
				if (pThis->pMainFrame->g_PacketDataList.Find(sPacketData) == NULL) {
					pThis->pMainFrame->g_PacketDataList.AddTail(sPacketData);
					pThis->pMainFrame->m_nArpCount += 1;
					pThis->pMainFrame->SetListView(nIndex);
					
				}

				nIndex = nIndex + 1;
			}
	
		}

		pPacketHeader = NULL;
		pPacketData = NULL;
		
	
	}
	
	pcap_close(pPcd);
	pThis->SendMessage(WM_CLOSE);
	return 0;
}
