// PacketGraphView.cpp : implementation file
//

#include "stdafx.h"
#include "PacketAnalyzer.h"
#include "PacketGraphView.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPacketGraphView

IMPLEMENT_DYNCREATE(CPacketGraphView, CView)

CPacketGraphView::CPacketGraphView()
{
	m_bGraphStatus = FALSE;
}

CPacketGraphView::~CPacketGraphView()
{
}


BEGIN_MESSAGE_MAP(CPacketGraphView, CView)
	//{{AFX_MSG_MAP(CPacketGraphView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPacketGraphView drawing

void CPacketGraphView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();

	// TODO: add draw code here
	CRect rect,rcClient;
	GetClientRect(rcClient);

//	pDC->FillSolidRect(rcClient,233+233*256+233*256*256);

//	return;
	COLORREF crLight = GetSysColor(COLOR_BTNHIGHLIGHT);
	COLORREF crShadow = GetSysColor(COLOR_BTNSHADOW);
	COLORREF crBtnFace = GetSysColor(COLOR_BTNFACE);

	pDC->SetBkMode(TRANSPARENT);
	CGdiObject *pOldFont = pDC->SelectStockObject(ANSI_VAR_FONT);

	rect = rcClient;

	// 1st rect
	rect.bottom = rect.top + 22;
	pDC->FillSolidRect(rect,crBtnFace);
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->DrawText("   Packet Capture",rect,DT_SINGLELINE|DT_VCENTER);
	
	rect.OffsetRect(0,22);
	pDC->FillSolidRect(rect,crBtnFace);
	pDC->Draw3dRect(rect,crLight,crShadow);
	pDC->DrawText("Graph",rect,DT_SINGLELINE|DT_VCENTER|DT_CENTER);
	
	// White rect
	rect.top = rect.bottom;
	rect.bottom = rcClient.bottom;
	pDC->FillSolidRect(rect,RGB(255,255,255));
	pDC->Draw3dRect(rect,crLight,crShadow);

	pDC->SelectObject(pOldFont);

	pDC->MoveTo(50,70);
	pDC->LineTo(50,270);
	
	pDC->MoveTo(50,270);
	pDC->LineTo(250,270);
	
	pDC->TextOut(10,85,"TCP");
	pDC->TextOut(10,135,"UDP");
	pDC->TextOut(8,185,"ICMP");
	pDC->TextOut(10,235,"ARP");
	pDC->TextOut(70,280,"TOTAL PACKET : ");
	
	

	if(m_bGraphStatus == TRUE)
	{
		CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
		int tcp,udp,icmp,arp,total;
		
		//ī ʱȭ
		total = pFrame->nIndex;
		tcp = pFrame->m_nTcpCount;
		udp = pFrame->m_nUdpCount;
		icmp = pFrame->m_nIcmpCount;
		arp = pFrame->m_nArpCount;
		
		//TOTAL ī 
		CString strBuff;
		strBuff.Format("%d",total);
		pDC->TextOut(190,280,strBuff);

		if(tcp != 0){
			//׷  
			CBrush tcp_brush, *tcp_oldbrush;				
			tcp_brush.CreateSolidBrush(RGB(8,80,255));	
			tcp_oldbrush = pDC->SelectObject(&tcp_brush);

			int tcpresult;
			
			//׷ 
			tcpresult = (((tcp*100)/total)*2)+50;
			pDC->Rectangle(50,90,tcpresult,100);
			//%
			CString strBuff;
			strBuff.Format("%3.1f",(double)(tcp*100)/total);
			pDC->TextOut(120,105,strBuff);
			pDC->TextOut(158,105,"%");
			
			//(tcp/total) 
			strBuff = "";
			CString strBuff2;
			strBuff2.Format("%d",tcp);
			strBuff.Format("%d",total);
			strBuff = "[ " + strBuff2 + " / " + strBuff + " ]";
			pDC->TextOut(175,105,strBuff);
						
			tcp_brush.DeleteObject();
		}
		if(udp != 0){
			//׷  
			CBrush udp_brush, *udp_oldbrush;				
			udp_brush.CreateSolidBrush(RGB(255,255,0));	
			udp_oldbrush = pDC->SelectObject(&udp_brush);
			
			int udpresult;
			
			//׷ 
			udpresult = (((udp*100)/total)*2)+50;
			pDC->Rectangle(50,140,udpresult,150);
			
			CString strBuff;
			strBuff.Format("%3.1f",(double)(udp*100)/total);
			pDC->TextOut(120,155,strBuff);
			pDC->TextOut(158,155,"%");
			
			//(udp/total) 
			strBuff = "";
			CString strBuff2;
			strBuff2.Format("%d",udp);
			strBuff.Format("%d",total);
			strBuff = "[ " + strBuff2 + " / " + strBuff + " ]";
			pDC->TextOut(175,155,strBuff);

			udp_brush.DeleteObject();
		}
		if(icmp != 0){
			//׷  
			CBrush icmp_brush, *icmp_oldbrush;				
			icmp_brush.CreateSolidBrush(RGB(255,8,0));	
			icmp_oldbrush = pDC->SelectObject(&icmp_brush);
			
			int icmpresult;
			
			//׷ 
			icmpresult = (((icmp*100)/total)*2)+50;
			pDC->Rectangle(50,190,icmpresult,200);
			
			CString strBuff;
			strBuff.Format("%3.1f",(double)(icmp*100)/total);
			pDC->TextOut(120,205,strBuff);
			pDC->TextOut(158,205,"%");

			//(icmp/total) 
			strBuff = "";
			CString strBuff2;
			strBuff2.Format("%d",icmp);
			strBuff.Format("%d",total);
			strBuff = "[ " + strBuff2 + " / " + strBuff + " ]";
			pDC->TextOut(175,205,strBuff);

			icmp_brush.DeleteObject();
		}
		if(arp != 0){
			//׷  
			CBrush arp_brush, *arp_oldbrush;				
			arp_brush.CreateSolidBrush(RGB(100,240,20));	
			arp_oldbrush = pDC->SelectObject(&arp_brush);

			int arpresult;
			
			//׷ 
			arpresult = (((arp*100)/total)*2)+50;
			pDC->Rectangle(50,240,arpresult,250);
			
			CString strBuff;
			strBuff.Format("%3.1f",(double)(arp*100)/total);
			pDC->TextOut(120,255,strBuff);
			pDC->TextOut(158,255,"%");
			
			//(arp/total) 
			strBuff = "";
			CString strBuff2;
			strBuff2.Format("%d",arp);
			strBuff.Format("%d",total);
			strBuff = "[ " + strBuff2 + " / " + strBuff + " ]";
			pDC->TextOut(175,255,strBuff);

			arp_brush.DeleteObject();
		}

	}

}

/////////////////////////////////////////////////////////////////////////////
// CPacketGraphView diagnostics

#ifdef _DEBUG
void CPacketGraphView::AssertValid() const
{
	CView::AssertValid();
}

void CPacketGraphView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPacketGraphView message handlers

void CPacketGraphView::SetGraphView()
{
	m_bGraphStatus = TRUE;
	Invalidate(FALSE);

}


void CPacketGraphView::ClearView()
{
	m_bGraphStatus = FALSE;
	UpdateData(FALSE);
	Invalidate(FALSE);
}
